{
    // Coeff extramaDist
    const unallocLabelList& owner = mesh.owner();
    const unallocLabelList& neighbour = mesh.neighbour();
    const vectorField& Cc = mesh.C();
    const scalarField& w = mesh.weights();

    volTensorField gradU = fvc::grad(hU, "coeff");
    surfaceVectorField snGradU = fvc::snGrad(hU, "coeff");
    
    scalarField coeffc(Cc.size(), 0.0);

    forAll(coeff, facei)
    {
        const label own = owner[facei];
        const label nei = neighbour[facei];

        vector sfhat = SfHat[facei];
        scalar gP = sfhat & (sfhat & (gradU[own]));
        scalar gN = sfhat & (sfhat & (gradU[nei]));
        scalar gf = sfhat & snGradU[facei];

        //vector df = Cc[nei] - Cc[own];
        ////scalar a2 = magSqr(Cc[own]);
        ////df *= Foam::sqrt(a2)*Foam::acos((Cc[nei] & Cc[own])/a2)/mag(df);
        //scalar gP = df & (df & (gradU[own]));
        //scalar gN = df & (df & (gradU[nei]));
        //scalar gf = (df & (U[nei] - U[own]));
        
        scalar wP = w[facei];
        scalar wN = 1 - wP;
        scalar A1 = 4*wP*wN*gf;
        scalar A2 = sqr(wN)*gN - sqr(wP)*gP - (1-2*wP)*gf;
        scalar A3 = wN*gN + wP*gP - gf;
        scalar c = sqr(A2) - A1*A3;

        scalar magA3 = mag(A3);
        if (c > 0 && magA3 > SMALL)
        //if (magA3 > SMALL)
        {
            scalar coefff = min(max
            (
                1 - sqr((magA3 - Foam::sqrt(c))/(ddtPhiCorrCoeff*magA3)),
                //1 - sqr((magA3 - c)/(ddtPhiCorrCoeff*magA3)),
                scalar(0)
            ), scalar(1));
            
            coeffc[own] = max(coeffc[own], coefff);
            coeffc[nei] = max(coeffc[nei], coefff);
            //coeff[facei] = coefff;
        }
        //else
        //{
        //    coeff[facei] = 0;
        //}
    }

    forAll(coeff, facei)
    {
        coeff[facei] = max(coeffc[owner[facei]], coeffc[neighbour[facei]]);
    }
    
    //forAll(coeff, facei)
    //{
    //    scalar coefff = 0.5*coeff[facei];
    //    coeffc[owner[facei]] = max(coeffc[owner[facei]], coefff);
    //    coeffc[neighbour[facei]] = max(coeffc[neighbour[facei]], coefff);
    //}
    //
    //forAll(coeff, facei)
    //{
    //    coeff[facei] = max(coeffc[owner[facei]], coeffc[neighbour[facei]]);
    //}
}


    // Coeff gradUf
    /*surfaceScalarField snGradU = SfHat &fvc::snGrad(hU, "coeff");
    surfaceScalarField gradUf = SfHat & 
    (
        SfHat & fvc::interpolate(fvc::grad(hU, "coeff"), "coeff")
    );
    coeff = mag(gradUf - snGradU)
       / max(mag(snGradU), dimensionedScalar("s", dimVelocity, VSMALL));
    */

Info << "min(coeff) = " << min(coeff.internalField()) 
     << " max(coeff) = " << max(coeff.internalField())
     << " mean(coeff) = " << gAverage(coeff) << endl;
