    Info << "\nReading initProperties" << endl;

    IOdictionary initProperties
    (
        IOobject
        (
            "initProperties",
            runTime.constant(),
            mesh,
            IOobject::MUST_READ,
            IOobject::NO_WRITE
        )
    );

    dimensionedScalar g(initProperties.lookup("g"));
    dimensionedScalar f(initProperties.lookup("f"));
    dimensionedVector F = f*vector(0,0,1);
    scalar ddtPhiCorrCoeff 
        = readScalar(initProperties.lookup("ddtPhiCorrCoeff"));

    Info<< "Reading field h\n" << endl;
    volScalarField h
    (
        IOobject
        (
            "h",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );

    Info<< "Reading field h0 if present\n" << endl;
    volScalarField h0
    (
        IOobject
        (
            "h0",
            "constant",
            mesh,
            IOobject::READ_IF_PRESENT
        ),
        mesh,
        dimensionedScalar("h0", dimLength, 0.0)
    );

    volScalarField coeff
    (
        IOobject
        (
            "ddtPhiCorrCoeff",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        mesh,
        dimensionedScalar("ddtPhiCorrCoeff", dimless, ddtPhiCorrCoeff)
    );

    Info<< "Reading field U\n" << endl;
    volVectorField U
    (
        IOobject
        (
            "U",
            runTime.timeName(),
            mesh,
            IOobject::MUST_READ,
            IOobject::AUTO_WRITE
        ),
        mesh
    );

    Info<< "Reading field hU\n" << endl;
    volVectorField hU
    (
        IOobject
        (
            "hU",
            runTime.timeName(),
            mesh,
            IOobject::READ_IF_PRESENT,
            IOobject::AUTO_WRITE
        ),
        h*U,
        U.boundaryField().types()
    );

#   include "createPhi.H"
